<?php

class Neo
{
    static $neolog_indent;
    static $neolog_connection_id;
    static $neolog_log_level;

    static function Init()
    {
        $strong;
        self::$neolog_connection_id = bin2hex( openssl_random_pseudo_bytes( 2, $strong ) );

        self::$neolog_log_level = intval( getenv( "SHOW_LOG_TO_LEVEL" ) );

        if ( ! is_numeric( self::$neolog_log_level ) )
        {
            self::$neolog_log_level = 100;
        }
    }

    static function In()
    {
        self::$neolog_indent++;
    }

    static function Out()
    {
        if ( 0 < self::$neolog_indent ) self::$neolog_indent--;
    }

    static function Log( $text )
    {
        $indent = intval( self::$neolog_indent    );
        $level  = intval( self::$neolog_log_level );

        if ( $indent <= $level )
        {
            self::LogError( $text );
        }
    }

    static function LogError( $text )
    {
        $now = isset( $_SERVER ) ? "" : date( DATE_ISO8601 );
    
        $stars = str_repeat( "+", self::$neolog_indent );

        error_log( sprintf( "[%s] %s%-8s %s", self::$neolog_connection_id, $now, $stars, $text ) );
    }
}

Neo::Init();

function NeoLog( $text )
{
    Neo::Log( $text );
}

function NeoLogError( $text )
{
    Neo::LogError( $text );
}

function NeoLogIn()
{
    Neo::In();
}

function NeoLogOut()
{
    Neo::Out();
}

